from funki.refactor_recommender import RefactorRecommender
import importlib
from os.path import exists
from pickle import load

def print_header(max_filename_length):
  name = "Name"
  duration_ms = "Duration [ms]"
  example_max_duration = "1024.567 █████████████████████"
  
  result ='\n'.join([
    f"| Result | {name:{max_filename_length}} | {duration_ms:^{len(example_max_duration)}}| ",
    f"|--------|-" + "-"*max_filename_length +"-|-" + "-"*len(example_max_duration)+"|"  
  ])
  print(result)

def test():
  rr = RefactorRecommender()
  rr.get_list_of_python_files('./src/funks')

  funk_filenames = [_ for _ in rr.python_files]
  funk_filenames.sort()

  durations = load('durations.pkl') if exists('durations.pkl') else {}
  durations_as_list = list(a.items())

  print()
  print(f'funk_filenames: {funk_filenames}')
  print(f'durations_as_list: {durations_as_list}')
  print()

  max_filename_length = max([len(_) for _ in funk_filenames]) - 15

  print_header(max_filename_length)

  for funk_filename in funk_filenames:
    module = importlib.import_module(
      funk_filename.replace('/','.').replace('..','')[:-3]
    )

    if not module.funk.test(max_filename_length):
      return False # Stop tests at first failure.
  return True # Reaching this point means all tests passed.
